# Convertit une chaine Hexa en Nombre
function Hex2Num (str)
{
 hexcode = "0123456789ABCDEF";
 # on retire ce qui peut etre en trop
 if (substr(str,1,2) == "0x") { gsub("0x","",str) }
 else if (index(str,"$") != 0) { gsub("$","",str) }
 else { str = str }
 str = toupper(str);
 # Process
 resu = 0;
 for(i=1;i<length(str)+1;i++)
 {
  digit = index(hexcode,substr(str,i,1))-1;
  if (digit == -1) { return (0) }
  resu = resu*16+digit;
 }
 return (resu);
}

#Convertit un nombre en binaire
function Num2Bin (num)
{
 
}

# Convertit une chaine Hexa en chaine Binaire
function Hex2Bin (str)
{
 # on retire ce qui peut etre en trop
 if (substr(str,1,2) == "0x") { gsub("0x","",str) }
 else if (index(str,"$") != 0) { gsub("$","",str) }
 else { str = str }
 str = toupper(str);
 gsub("0","0000",str);
 gsub("1","0001",str);
 gsub("2","0010",str);
 gsub("3","0011",str);
 gsub("4","0100",str);
 gsub("5","0101",str);
 gsub("6","0110",str);
 gsub("7","0111",str);
 gsub("8","1001",str);
 gsub("9","1000",str);
 gsub("A","1011",str);
 gsub("B","1010",str);
 gsub("C","1100",str);
 gsub("D","1101",str);
 gsub("E","1110",str);
 gsub("F","1111",str);
 return(str)
}


BEGIN {
 # This is to run in DOS mode
 RS="\r\n"
}

 /Dumping file/		{ 
			 file = $0
			 sub("; Dumping file ","", file) 
			}

 /'OS\/2' version/	{ OS2Version = $3 }
 /xAvgCharWidth/	{ xAvgCharWidth = $2 }
 /usWeightClass/        { usWeightClass = $2 }
 /usWidthClass/		{ usWidthClass = $2 }
 /fsType/		{ fsType = $2 }
 /ySubscriptXSize/	{ ySubscriptXSize = $2 }
 /ySubscriptYSize/	{ ySubscriptYSize = $2 }
 /ySubscriptXOffset/	{ ySubscriptXOffset = $2 }
 /ySubscriptYOffset/	{ ySubscriptYOffset = $2 }
 /ySuperscriptXSize/	{ ySuperscriptXSize = $2 }
 /ySuperscriptYSize/	{ ySuperscriptYSize = $2 }
 /ySuperscriptXOffset/	{ ySuperscriptXOffset = $2 }
 /ySuperscriptYOffset/	{ ySuperscriptYOffset = $2 }
 /yStrikeoutSize/	{ yStrikeoutSize = $2 }
 /yStrikeoutPosition/	{ yStrikeoutPosition = $2 }
 /sFamilyClass/         { sFamilyClass = $2; sFamilyClass_subclass = $5 }
 /PANOSE/		{ 
 			 bFamilyType = $2;
			 bSerifStyle = $3;
			 bWeight = $4;
			 bProportion = $5;
			 bContrast = $6;
			 bStrokeVariation = $7;
			 bArmStyle = $8;
			 bLetterForm = $9;
			 bMidline = $10;
			 bXHeight = $11;
			}
 /Unicode Range 1/  { ulUnicodeRange1 = $9 }
 /Unicode Range 2/  { ulUnicodeRange2 = $8 }
 /Unicode Range 3/  { ulUnicodeRange3 = $8 }
 /Unicode Range 4/  { ulUnicodeRange4 = $7 }
 /achVendID/		{ achVendID = $2 }
 /fsSelection/		{ fsSelection = $2 }
 /usFirstCharIndex/	{ usFirstCharIndex = $2 }
 /usLastCharIndex/	{ usLastCharIndex = $2 }
 /sTypoAscender/	{ sTypoAscender = $2 }
 /sTypoDescender/	{ sTypoDescender = $2 }
 /sTypoLineGap/		{ sTypoLineGap = $2 }
 /usWinAscent/		{ usWinAscent = $2 }
 /usWinDescent/		{ usWinDescent = $2 }
 /CodePage Range 1/	{ ulCodePageRange1 = $9 }
 /CodePage Range 2/	{ ulCodePageRange2 = $8 }
 
END {
 #printf("%s;%d;%04X;%s\n",fsType,fsSelection,HexToBin(fsSelection))
 printf("%s|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%d|%s|%s|%s|%s|%s|%d|%d|%d|%d|%d|%d|%d|%d|%d|%s|%s\n", file, OS2Version, xAvgCharWidth, usWeightClass, usWidthClass , Hex2Num(fsType) , ySubscriptXSize , ySubscriptYSize , ySubscriptXOffset , ySubscriptYOffset , ySuperscriptXSize , ySuperscriptYSize , ySuperscriptXOffset , ySuperscriptYOffset , yStrikeoutSize , yStrikeoutPosition , sFamilyClass , sFamilyClass_subclass , bFamilyType , bSerifStyle , bWeight , bProportion , bContrast , bStrokeVariation , bArmStyle , bLetterForm , bMidline , bXHeight, Hex2Bin(ulUnicodeRange1) , Hex2Bin(ulUnicodeRange2) , Hex2Bin(ulUnicodeRange3) , Hex2Bin(ulUnicodeRange4) , achVendID , Hex2Num(fsSelection) , Hex2Num(usFirstCharIndex) , Hex2Num(usLastCharIndex) , sTypoAscender , sTypoDecender , sTypoLineGap , usWinAscent , usWinDescent , Hex2Bin(ulCodePageRange1) , Hex2Bin(ulCodePageRange2))
}
